from sqlobject import *
import model

import cherrypy
from cherrypy.lib import httptools
from cherrytemplate import renderTemplate
from formencode import htmlform
import time

class Root:
    def __init__(self, view_config):
        self.dsn = view_config['dsn']
        p = PostgresConnection(self.dsn)
        sqlhub.processConnection = p

    def new(self, **kwargs):
        today = time.strftime('%Y-%m-%d', time.localtime())
        html = renderTemplate(file='templates/new.html')
        form = htmlform.HTMLForm(html, model.BlogPostScheme)
        if kwargs.has_key('date'):
            form_result, errors = form.validate(kwargs)
            if errors:
                return form.render(kwargs, errors)
            else:
                p = model.BlogPost(title = kwargs['title'], 
                          body = kwargs['body'], date = today)
                return self.view(p.id)
        else:
            return html
    new.exposed = True

    def view(self, post=0):
        try: postid = int(post)
        except TyepError: self.index
        blogpost = model.BlogPost.select(model.BlogPost.q.id == postid)[0]
        return renderTemplate(file='templates/view.html')
    view.exposed = True

    def index(self):
        posts = model.BlogPost.select('id > 0')
        return renderTemplate(file='templates/index.html')
    index.exposed = True

view_config = { 'dsn': 'dbname=bloggy', }

def main():
    cherrypy.root = Root(view_config)
    cherrypy.config.update(file = 'simple.conf')
    cherrypy.config.update({'sessionFilter.on': True})
    cherrypy.server.start()

if __name__ == '__main__': main()



